Import Dom From "lib/web/dom.bas"
Dom.Container().style.overflow = "hidden"

Dim Shared reset As Integer
Dim Shared frameOffset As _Unsigned Long
GXSceneCreate 1400, 256 '700, 128

' setup the background
Dim As Long bg, bg2
bg = GXBackgroundAdd("img/bg-sky.png", GXBG_STRETCH)
bg2 = GXBackgroundAdd("img/bg-clouds.png", GXBG_WRAP)
bg3 = GXBackgroundAdd("img/bg-hills.png", GXBG_WRAP)
bg4 = GXBackgroundAdd("img/bg-middle.png", GXBG_WRAP)
GXBackgroundWrapFactor bg2, .1
GXBackgroundWrapFactor bg3, .3
GXBackgroundWrapFactor bg4, .5

' load the map
GXMapLoad "map/banner.gxm.json"
GXMapLayerVisible 4, GX_FALSE

' create the player
Dim Shared player As Integer
player = GXEntityCreate("img/character.png", 16, 20, 4)
GXEntityPos player, -25, 190 '75, 190
GXEntityCollisionOffset player, 3, 10, 3, 0
GXEntityVX player, 150
GXEntityAnimate player, 1, 20
GXEntityApplyGravity player, GX_TRUE

Dim Shared logo As Integer
logo = GXScreenEntityCreate("img/peLogo.png", 135, 135, 1)
GXEntityPos logo, _WIDTH - 150, 20

' setup the scene
GXScenePos 0, 14 '128
GXSceneFollowEntity player, GXSCENE_FOLLOW_ENTITY_CENTER_X
GXSceneConstrain GXSCENE_CONSTRAIN_TO_MAP

'GXDebug GX_TRUE
GXSceneStart

Sub GXOnGameEvent (e As GXEvent)
    Select Case e.event
        Case GXEVENT_UPDATE: OnUpdate e
        Case GXEVENT_COLLISION_TILE: OnTileCollision e
    End Select
End Sub

Sub OnUpdate (e as GXEvent)
    If reset Then
        reset = GX_FALSE
        GXEntityPos player, -25, 190 '75, 190
        GXEntityApplyGravity player, GX_TRUE
        frameOffset = GXFrame - 1
    End If

    'GXScenePos GXSceneX + 1, GXSceneY
    Dim frame As _Unsigned Long
    frame = GXFrame - frameOffset
    If frame = 40 Or frame = 220 Or frame = 385 Or _
       frame = 435 Or frame = 475 Or frame = 524 Or _
       frame = 597 Or frame = 665 Or frame = 800 Or _
       frame = 875 Or frame = 916 Or frame = 956 Or _
       frame = 1000 Or frame = 1041 Or frame = 1092 Or _
       frame = 1214 Or frame = 1285 Then
        GXEntityVY player, -120 ' jump
    End If

    If frame > 1450 Then
        reset = GX_TRUE
        GXEntityApplyGravity player, GX_FALSE
        GXEntityVY = 0
    End If


    If GXEntityVY(player) = 0 Then
        GXEntityAnimate player, 1, 20
    Else
        GXEntityAnimate player, 1, 0
        GXEntityFrameSet player, 1, 2
    End If
End Sub

Sub OnTileCollision (e as GXEvent)
    Dim tile As Integer
    tile = GXMapTile(e.collisionTileX, e.collisionTileY, 4)
    If tile > 0 Then e.collisionResult = 1
End Sub