Import Dom From "lib/web/dom.bas"
Dom.Container().style.overflow = "hidden"

Dim Shared reset As Integer
Dim Shared manual As Integer
Dim Shared mouseDown As Integer
Dim Shared frameOffset As _Unsigned Long
If _ResizeWidth < 1200 Then
    GXSceneCreate 485, 128
Else
    GXSceneCreate 700, 128
End If

'---------------
Const xmax = _Width
Const ymax = _Height
Dim Shared doStars
Dim Shared r, g, b, clr
Dim Shared cx, cy, size, radius, angle, sangle, x, y, r2
cx = xmax / 2: cy = ymax / 2: r = Rnd: g = Rnd: b = Rnd

'---------------



GXSceneScale 2

' setup the background
Dim As Long bg, bg2
bg = GXBackgroundAdd("img/bg-sky.png", GXBG_STRETCH)
bg2 = GXBackgroundAdd("img/bg-clouds.png", GXBG_WRAP)
bg3 = GXBackgroundAdd("img/bg-hills.png", GXBG_WRAP)
bg4 = GXBackgroundAdd("img/bg-middle.png", GXBG_WRAP)
GXBackgroundWrapFactor bg2, .1
GXBackgroundWrapFactor bg3, .3
GXBackgroundWrapFactor bg4, .5

' load the map
GXMapLoad "map/banner.gxm.json"
GXMapLayerVisible 4, GX_FALSE

' create the player
Dim Shared player As Integer
player = GXEntityCreate("img/adventurer.png", 50, 37, 6)
GXEntityPos player, -41, 178 
GXEntityCollisionOffset player, 16, 26, 16, 1
GXEntityVX player, 150
GXEntityAnimate player, 1, 20
GXEntityApplyGravity player, GX_TRUE

Dim Shared logo As Integer
logo = GXScreenEntityCreate("img/peLogo-small.png", 100, 100, 1)
GXEntityPos logo, GXSceneWidth - GXEntityWidth(logo) - 5, 5


' setup the scene
GXScenePos 0, 14 '128
GXSceneFollowEntity player, GXSCENE_FOLLOW_ENTITY_CENTER
GXSceneConstrain GXSCENE_CONSTRAIN_TO_MAP

'GXDebug GX_TRUE
GXSceneStart

Sub GXOnGameEvent (e As GXEvent)
    Select Case e.event
        Case GXEVENT_UPDATE: OnUpdate e
        Case GXEVENT_COLLISION_TILE: OnTileCollision e
        Case GXEVENT_DRAWSCREEN: OnDrawScreen e
    End Select
End Sub

Sub OnDrawScreen (e As GXEvent)
    If GXDebug Then
        GXDrawText GXFONT_DEFAULT_BLACK, 1, 1, Str$(GXEntityX(player))
    End If
    If doStars Then DrawStars
End Sub

Sub OnUpdate (e As GXEvent)
    If reset Then
        doStars = GX_FALSE
        reset = GX_FALSE
        manual = GX_FALSE
        GXEntityPos player, -41, 150 '75, 190
        GXEntityApplyGravity player, GX_TRUE
        frameOffset = GXFrame - 1
    End If

    Dim frame As _Unsigned Long
    frame = GXFrame - frameOffset
    
    If _MouseButton(1) Then
        If not mouseDown Then
            mouseDown = GX_TRUE
            manual = GX_TRUE
            If GXEntityVY(player) = 0 Then
                GXEntityVY player, -120 ' jump
            End If
        End If
    Else
        mouseDown = GX_FALSE
    End If

    If Not manual Then
        If frame = 40 Or frame = 220 Or frame = 385 Or _
           frame = 435 Or frame = 475 Or frame = 524 Or _
           frame = 597 Or frame = 665 Or frame = 800 Or _
           frame = 875 Or frame = 916 Or frame = 956 Or _
           frame = 1000 Or frame = 1041 Or frame = 1092 Or _
           frame = 1214 Or frame = 1285 Then
            GXEntityVY player, -120 ' jump
        End If
    End If
    
    If GXEntityX(player) > 3600 Or GXEntityY(player) > (_Height + 200) Then
        reset = GX_TRUE
        GXEntityApplyGravity player, GX_FALSE
        GXEntityVY = 0
    End If
    
    If GXEntityY(player) > _Height Then doStars = GX_TRUE


    If GXEntityVY(player) = 0 Then
        GXEntityAnimate player, 1, 20
    ElseIf GXEntityVY(player) <= -75 Then
        GXEntityAnimate player, 1, 0
        GXentityFrameSet player, 2, 3
    ElseIf Abs(GXEntityVY(player)) < 75 Then
        GXEntityAnimate player, 1, 0
        GXentityFrameSet player, 2, 4
    ElseIf GXEntityVY(player) >= 75 Then
        GXEntityAnimate player, 3, 20
    Else
        GXEntityAnimate player, 1, 0
        GXEntityFrameSet player, 1, 2
    End If
    
    GXEntityVX player, 150
End Sub

Sub OnTileCollision (e as GXEvent)
    Dim tile As Integer
    tile = GXMapTile(e.collisionTileX, e.collisionTileY, 4)
    If tile > 0 Then e.collisionResult = 1
End Sub


Sub DrawStars
'While doStars
    size = 1
    radius = .06
    angle = sangle
    'Cls
    While radius < 800
        x = Cos(angle) * radius
        y = Sin(angle) * radius
        r2 = (x ^ 2 + y ^ 2) ^ .5
        size = 4 * r2 ^ .25
        For r = size To 1 Step -4
            'cc = 160 + 95 * radius/400 - r/size*120
            chColor
            star cx + x, cy + y, r / 3, r * 1.6, 5, Rnd * 360
        Next
        angle = angle - .4
        radius = radius + 1
    Wend
'    _Display ' update screen with new image
'    _Limit 60 '<<<<<<<<<<<<<<<<<<<<<<<<<< adjust to higher speeds if you dare
    sangle = sangle + _Pi(1 / 18)
'Wend
End Sub

Sub star (x, y, rInner, rOuter, nPoints, angleOffset)
    ' x, y are same as for circle,
    ' rInner is center circle radius
    ' rOuter is the outer most point of star
    ' nPoints is the number of points,
    ' angleOffset = angle offset IN DEGREES, it will be converted to radians in sub
    ' this is to allow us to spin the polygon of n sides
    Dim pAngle, radAngleOffset, x1, y1, i, x2, y2, x3, y3
    pAngle = RAD(360 / nPoints): radAngleOffset = RAD(angleOffset)
    x1 = x + rInner * Cos(radAngleOffset)
    y1 = y + rInner * Sin(radAngleOffset)
    For i = 0 To nPoints - 1
        x2 = x + rOuter * Cos(i * pAngle + radAngleOffset + .5 * pAngle)
        y2 = y + rOuter * Sin(i * pAngle + radAngleOffset + .5 * pAngle)
        x3 = x + rInner * Cos((i + 1) * pAngle + radAngleOffset)
        y3 = y + rInner * Sin((i + 1) * pAngle + radAngleOffset)
        Line (x1, y1)-(x2, y2)
        Line (x2, y2)-(x3, y3)
        x1 = x3: y1 = y3
    Next
End Sub


Sub chColor ()
    clr = clr + 1
    Color _RGB32(127 + 127 * Sin(r * clr), 127 + 127 * Sin(g * clr), 127 + 127 * Sin(b * clr))
    If clr > 100000 Then r = Rnd * Rnd: g = Rnd * Rnd: b = Rnd * Rnd: clr = 0
End Sub
Function RAD (dA)
    RAD = _Pi(dA / 180)
End Function